Subject: [TLS] (offline) Re: Draft for SM cipher suites used in TLS1.3

From: Rene Struik <[email-masked]>
Date: Fri, 16 Aug 2019 10:58:13 -0400

Arguably, "national" crypto specifications garnish more stature if these 
are made available to the pubic by that standard-setting body itself 
(who, thereby, acts as its authoritative source), without deference to a 
third party (that may, independently from the originator, enforce 
document control [e.g., by effectuating technical changes or enforcing 
controlled dissemination]).

Since your draft introducing SM cipher suites with TLS1.3 appeals to the 
authority of a standard-setting authority, easy availability of the full 
and accredited technical documentation to the IETF community helps in 
scrutiny and, e.g., evaluating claims in the security considerations 
section.

On 8/16/2019 3:06 AM, Kepeng Li wrote:
> Hi Rene and all,
>
> > Since the ISO documents are not available to the general > public without payment, it would be helpful to have a freely 
> available > document (in English) from an authoritative source. Having 
> such a > reference available would be helpful to the IETF community 
> (and > researchers).
> About the references to ISO documens, I think it is a general issue 
> for IETF drafts.
>
> How does the other IETF drafts make the references to ISO documents? 
> ISO documents are often referenced by IETF drafts.
>
> Thanks,
>
> Kind Regards
> Kepeng
> ——————————————————————————————————————————————————————————————————
>
>
>       Re: [TLS] Draft for SM cipher suites used in TLS1.3
>
> Rene Struik <[email-masked] <mailto:[email-masked]>>Thu, 
> 15 August 2019 15:34 UTCShow header 
> <https://mailarchive.ietf.org/arch/browse/tls/?index=NHbHOGtsR1S5cCr9nWN9_sdyTgg&gbt=1#>
>
> Hi Paul:
>
> I tried and look up the documents GMT.0009-2012 and GBT.32918.5-2016 on
> the (non-secured) websites you referenced, but only found Chinese
> versions (and Chinese website navigation panels [pardon my poor language
> skills here]). Since the ISO documents are not available to the general
> public without payment, it would be helpful to have a freely available
> document (in English) from an authoritative source. Having such a
> reference available would be helpful to the IETF community (and
> researchers). Please note that BSI provides its specifications in German
> and English, so as to foster use/study by the community. If the Chinese
> national algorithms would be available in similar form, this would serve
> a similar purpose.
>
> FYI - I am interested in full details and some time last year I tried to
> download specs, but only Parts 2, 4, and 5 were available [1], [2], [3],
> not Parts 1 and 3.
>
> Best regards, Rene
>
> [1] China ECC - Public Key Cryptographic Algorithm SM2 Based on ECC -
> Part 5 - Parameter Definition (SEMB, July 24, 2018)
> [2] China ECC - Public Key Cryptographic Algorithm SM2 Based on ECC -
> Part 2 - Digital Signature Algorithm (SEMB, July 24, 2018)
> [3] China ECC - Public Key Cryptographic Algorithm SM2 Based on ECC -
> Part 4 - Public Key Encryption Algorithm (SEMB, July 24, 2018)
>
> On 8/15/2019 10:16 AM, Paul Yang wrote:
> > Hi all,
> >
> > I have submitted a new internet draft to introduce the SM cipher 
> > suites into TLS 1.3 protocol.
> >
> > https://tools.ietf.org/html/draft-yang-tls-tls13-sm-suites-00
> >
> > SM cryptographic algorithms are originally a set of Chinese national 
> > algorithms and now have been (or being) accepted by ISO as 
> > international standards, including SM2 signature algorithm, SM3 hash 
> > function and SM4 block cipher. These algorithms have already been 
> > supported some time ago by several widely used open source 
> > cryptographic libraries including OpenSSL, BouncyCastle, Botan, etc.
> >
> > Considering TLS1.3 is being gradually adopted in China's internet 
> > industry, it's important to have a normative definition on how to use 
> > the SM algorithms with TLS1.3, especially for the mobile internet 
> > scenario. Ant Financial is the company who develops the market leading 
> > mobile app 'Alipay' and supports payment services for Alibaba 
> > e-commerce business. We highly are depending on the new TLS1.3 
> > protocol for both performance and security purposes. We expect to have 
> > more deployment of TLS1.3 capable applications in China's internet 
> > industry by this standardization attempts.
> >
> > It's very appreciated to have comments from the IETF TLS list :-)
> >
> > Many thanks!
> >
> > _______________________________________________
> > TLS mailing list
> > [email-masked]  <mailto:[email-masked]>
> > https://www.ietf.org/mailman/listinfo/tls
>

-- 
email: [email-masked] | Skype: rstruik
cell: +1 (647) 867-5658 | US: +1 (415) 690-7363

---

From: "Salz, Rich" <[email-masked]>
Date: Fri, 16 Aug 2019 15:06:50 +0000

>How does the other IETF drafts make the references to ISO documents? ISO documents are often referenced by IETF drafts.

Can you point to specific drafts where *normative* references are only available for paying a fee?  I guess that there are some, but I don’t know of any. Your claim implies definitive knowledge, however.

In general, the IETF tends to dislike using standards where the specification is not freely available in English. That last part, in English, is perhaps narrow-minded these days, but the IETF works in English.  Also, note that I said “tends to dislike” and didn’t claim a hard rule always enforced.  In the past, where there have been issues, it has been not uncommon to write internet-drafts and publish through CFRG; see https://datatracker.ietf.org/rg/cfrg/documents/ for many examples. Sometimes they are published as individual stream RFC’s; see https://tools.ietf.org/html/rfc7091 for a highly applicable example.

---

From: Paul Yang <[email-masked]>
Date: Sat, 17 Aug 2019 13:01:39 +0800

Good points.

The good news is that we have found some English PDFs of SM2, including the missing part 1 and part 3. Will continue to find English translations of other SM standards mentioned in the draft.

So, if we host a free website, say on Github or so, to provide those docs, is it convenient for you guys? Or should we just drop the   PDF files to this mailing list as attachments?

> On Aug 16, 2019, at 10:58 PM, Rene Struik <[email-masked]> wrote:
> 
> Arguably, "national" crypto specifications garnish more stature if these are made available to the pubic by that standard-setting body itself (who, thereby, acts as its authoritative source), without deference to a third party (that may, independently from the originator, enforce document control [e.g., by effectuating technical changes or enforcing controlled dissemination]).
> 
> Since your draft introducing SM cipher suites with TLS1.3 appeals to the authority of a standard-setting authority, easy availability of the full and accredited technical documentation to the IETF community helps in scrutiny and, e.g., evaluating claims in the security considerations section.
> 
>> > Since the ISO documents are not available to the general
>> > researchers).
>> About the references to ISO documens, I think it is a general issue for IETF drafts.
>> 
>> Rene Struik <[email-masked] <mailto:[email-masked]>> Thu, 15 August 2019 15:34 UTCShow header <https://mailarchive.ietf.org/arch/browse/tls/?index=NHbHOGtsR1S5cCr9nWN9_sdyTgg&gbt=1#>
>> Hi Paul:
>> 
>> > https://tools.ietf.org/html/draft-yang-tls-tls13-sm-suites-00 <https://tools.ietf.org/html/draft-yang-tls-tls13-sm-suites-00>
>> >
>> > https://www.ietf.org/mailman/listinfo/tls <https://www.ietf.org/mailman/listinfo/tls>
> 
> --
> email: [email-masked] <mailto:[email-masked]> | Skype: rstruik
> [email-masked]

Regards,

Paul Yang

---

From: "Kepeng Li" <[email-masked]>
Date: Sun, 18 Aug 2019 16:09:17 +0800

>Can you point to specific drafts where *normative* references are only available for paying a fee?  I guess that there are some, but I don’t know of any. 
This is one example: https://www.rfc-editor.org/rfc/rfc8428.txt
[RNC]; ISO/IEC, "Information technology -- Document Schema Definition Language (DSDL) -- Part 2: Regular-grammar-based validation -- RELAX NG", ISO/IEC 19757-2, Annex C: RELAX NG Compact syntax, December 2008.
Kind Regards
Kepeng

--------------------------
发件人:Salz, Rich<[email-masked]>
日期：8月16日 23:06
收件人：Kepeng Li<[email-masked]>
输入主题Re: [TLS] (offline) Re: Draft for SM cipher suites used in TLS1.3

---

From: Anders Rundgren <[email-masked]>
Date: Sun, 18 Aug 2019 11:44:29 +0200

Couldn't a group petition from the IETF request ISO and their member states to reconsider the use fee based standards?
This concept is incompatible with most current standards developments, be it in the IETF, W3C, or industry consortia as well a with Open Source.

Fee based standards represent an hurdle for innovation and adoption of new technology.

thanx,
Anders Rundgren

On 2019-08-18 10:09, Kepeng Li wrote:
>>Can you point to specific drafts where **normative** references are only available for paying a fee?  I guess that there are some, but I don’t know of any.
> 
> *日期：*8月16日 23:06
> *收件人：*Kepeng Li<[email-masked]>
> *输入主题*Re: [TLS] (offline) Re: Draft for SM cipher suites used in TLS1.3
> 
> 
> *>*How does the other IETF drafts make the references to ISO documents? ISO documents are often referenced by IETF drafts.
> 
>   
> 
> Can you point to specific drafts where **normative** references are only available for paying a fee?  I guess that there are some, but I don’t know of any. Your claim implies definitive knowledge, however.
>

---

From: Paul Yang <[email-masked]>
Date: Sun, 18 Aug 2019 19:55:11 +0800

No, I just found the 'RelaxNG' (The [RNC] ISO/IEC reference in
RFC8428) has free specifications (Standardized by OASIS) other than
the ISO version, check: https://relaxng.org/#specs. So it's not only
available for paying a fee.

I think we need to provide such stuffs alongside the ISO files
mentioned in our draft.

-- 
Regards

Paul Yang

---

From: "Salz, Rich" <[email-masked]>
Date: Sun, 18 Aug 2019 12:52:07 +0000

Ø  This is one example: https://www.rfc-editor.org/rfc/rfc8428.txt

Thank you.

That is a bit different since RNC isn’t needed to implement the RFC, and a web search for “relaxng” finds thousands of references.  The SM2, etc., situation is different because you cannot implement the cipher without the definition of it.

---

From: Eric Rescorla <[email-masked]>
Date: Sun, 18 Aug 2019 15:47:39 +0200

The intent of the "Specification Required" requirement for registration is
that sufficient public information be available to allow an interoperable
implementation. Specifically, the text says:

https://tools.ietf.org/html/rfc8126#section-4.6

   For the Specification Required policy, review and approval by a
   designated expert (see Section 5) is required, and the values and
   their meanings must be documented in a permanent and readily
   available public specification, in sufficient detail so that
   interoperability between independent implementations is possible.
   This policy is the same as Expert Review, with the additional
   requirement of a formal public specification.  In addition to the
   normal review of such a request, the designated expert will review
   the public specification and evaluate whether it is sufficiently
   stable and permanent, and sufficiently clear and technically sound to
   allow interoperable implementations.

I don't think that a for-pay specification meets that threshold, though I'm
not aware of any IETF-wide policy on that (although I may just have missed
it).

In the absence of that, it would as stated above, be on the Expert to
determine
the standard.

-Ekr

---

From: "Blumenthal, Uri - 0553 - MITLL" <[email-masked]>
Date: Sun, 18 Aug 2019 14:07:54 +0000

IMHO, placing the documents on GitHub would be perfect, and quite sufficient. 

Please make sure to post the name of the repo here. ;/)

I leave it to others to decide whether they'd want copies of today PDF files sent to the mailing list directly.

Regards,
Uri

Sent from my iPhone

> On Aug 17, 2019, at 01:03, Paul Yang <kaishen.yy=[email-masked]> wrote:
> 
> Good points.
> 
>>> Rene Struik <[email-masked]> Thu, 15 August 2019 15:34 UTCShow header
>>> 
>>> Hi Paul:
>>>

---

From: Paul Yang <[email-masked]>
Date: Mon, 19 Aug 2019 22:32:21 +0800

> On Aug 18, 2019, at 9:47 PM, Eric Rescorla <[email-masked]> wrote:
> 
> The intent of the "Specification Required" requirement for registration is that sufficient public information be available to allow an interoperable implementation. Specifically, the text says:
> 
> https://tools.ietf.org/html/rfc8126#section-4.6 <https://tools.ietf.org/html/rfc8126#section-4.6>
> 

Makes sense, so we added new public documents now ;-)

Just one question, do implementations count as the ‘public specification’? For instance, something like the crypto libraries which support the algorithms with full documentation describing it...

> 
> In the absence of that, it would as stated above, be on the Expert to determine
> the standard.
> 
> -Ekr
> 
> 
> 
> 
> 
> On Sun, Aug 18, 2019 at 2:52 PM Salz, Rich <[email-masked] <mailto:[email-masked]>> wrote:
> 
> Ø  This is one example: https://www.rfc-editor.org/rfc/rfc8428.txt <https://www.rfc-editor.org/rfc/rfc8428.txt>
> 
> Thank you.
> 

Regards,

Paul Yang

---

From: Eric Rescorla <[email-masked]>
Date: Mon, 19 Aug 2019 10:10:12 -0700

On Mon, Aug 19, 2019 at 7:32 AM Paul Yang <[email-masked]> wrote:

> Just one question, do implementations count as the ‘public specification’?
> For instance, something like the crypto libraries which support the
> algorithms with full documentation describing it...
>

I do not think so, no.

-Ekr

---

From: "Kepeng Li" <[email-masked]>
Date: Mon, 19 Aug 2019 17:38:40 +0800

Hi WG chairs,

Can we place the referenced documents in the TLS WG GitHub?

https://github.com/tlswg

According to the discussion below, this can help people to read and understand the referenced specifications.

Thanks,

Kind Regards

Kepeng 

发件人: TLS <[email-masked]> 代表 "Blumenthal, Uri - 0553 - MITLL" <[email-masked]>
日期: 2019年8月18日 星期日 22:08
收件人: Paul Yang <kaishen.yy=[email-masked]>
抄送: "[email-masked]" <[email-masked]>
主题: Re: [TLS] (offline) Re: Draft for SM cipher suites used in TLS1.3

Regards,

Uri

Sent from my iPhone

Good points.

Hi Rene and all,

Thanks,

Kind Regards

Kepeng

 

Best regards, Rene

 

Regards,

Paul Yang

_______________________________________________ TLS mailing list [email-masked] https://www.ietf.org/mailman/listinfo/tls

---

From: Sean Turner <[email-masked]>
Date: Mon, 19 Aug 2019 13:43:31 -0400

Kepeng,

It seems that this request is OBE (over taken by events) now that you’ve posted the referenced specifications to:
https://github.com/alipay/tls13-sm-spec

Cheers,

spt

> On Aug 19, 2019, at 05:38, Kepeng Li <[email-masked]> wrote:
> 
> Hi WG chairs,
>

---

From: Joseph Salowey <[email-masked]>
Date: Mon, 19 Aug 2019 12:25:59 -0800

Hi Folks,

It is in the hands of the designated experts and not the working group at large to determine what is an acceptable reference. Because of this we're asking participants to limit their discussion on this particular aspect of this topic.  

The registry policy for cipher suites is specification required as determined by the designated experts.  The role of the designated expert is described in [RFC8447] as:

"The designated expert [RFC8126] ensures that the specification is
publicly available.  It is sufficient to have an Internet-Draft that is posted 
and never published as an RFC) or a document from
another standards body, industry consortium, university site, etc.
The expert may provide more in-depth reviews, but their approval
should not be taken as an endorsement of the cipher suite."

 Thanks, 

Sean, Chis, and Joe

[RFC8447] https://tools.ietf.org/html/rfc8447
[RFC8126] https://tools.ietf.org/html/rfc8126